module ksa ( 
				input logic CLOCK_50,
				input logic[3:0] KEY,
				input logic[9:0] SW,
				output logic[9:0] LEDR,
				output logic[6:0] HEX0,
				output logic[6:0] HEX1,
				output logic[6:0] HEX2,
				output logic[6:0] HEX3,
				output logic[6:0] HEX4,
				output logic[6:0] HEX5);

					
	logic clk, rst_n, a_req_in, b_req_out, a_req_out, a_done, b_req_in, b_done; 
	assign clk = CLOCK_50;
	assign rst_n = KEY[3];
		 
	logic [7:0]e_addr, e_out, a_address, data_out, b_address;
	
	
	logic [9:0] i;
	logic [23:0] key;
	
	logic start, busy, success, busy_b, success_b;
	assign LEDR = {a_req_in, a_req_out, data_out};
	assign start = 1;
	assign key = {{14'b0}, {SW[9:0]}};
	
	//State Machine
	
	
	e_memory (.clock(clk), .address(e_addr), .q(e_out));
	
	datapath d1 (
		.clk(clk),
		.rst(rst_n),
		
		.start(start),
		.busy(busy),
		.success(success),
		
		.e_address (a_address),
		.e_data_out (data_out),
		
		.mem_done (a_done),
		.mem_request(a_req_in),
	
		.keyGiven(key),
		.testOut(i)
		//.i(i)
	);
	
	datapath d2 (
		.clk(clk),
		.rst(rst_n),
		
		.start(start),
		.busy(busy_b),
		.success(success_b),
		
		.e_address (b_address),
		.e_data_out (data_out),
		
		.mem_done (b_done),
		.mem_request(b_req_in),
	
		.keyGiven(24'b1001001001),
		.testOut()
		//.i(i)
	);
	
	logic clrA, clrB;
	encrypted_access_controller n1(
	
		.a_req(a_req_out),
		.b_req(b_req_out),
		.c_req(1'b0),
		.d_req(1'b0),
		
		.clrA (clrA),
		.clrB (clrB),
		.clrC (1'b0),
		.clrD (1'b0),
		
		.clk (clk),
		.reset (rst_n),
		
		.a_done(a_done),
		.b_done(b_done),
		.c_done(1'b0),
		.d_done(1'b0),
		
		.a_address(a_address),
		.b_address(b_address),
		.c_address(8'b0),
		.d_address(8'b0),
		
		.data_out(data_out),
		
		.e_data (e_out),
		.e_address (e_addr)
		
	
	);
	
	memoryRequestHandler A (
		.d (a_req_in),
		.q (a_req_out),
		.reset (clrA)
	);
	
		memoryRequestHandler B (
		.d (b_req_in),
		.q (b_req_out),
		.reset (clrB)
	);
	/*
	// initializing the RAM with values.  S[i] = i
	assign ram_Init_FSM_en = ram_Init_FSM_data_addr <= 8'd255 ? 1'b1: 1'b0; // finish counting after reaching 255
	ff_en_rstAsync #(.M(8)) init_ram_FSM ( .clk(clk), .en(ram_Init_FSM_en), .rst_n(rst_n), 
														.in(ram_Init_FSM_data_addr +8'b1), .out(ram_Init_FSM_data_addr));
	
	
	// instantiating the 256 word 8bit RAM
	s_memory (.clock(clk), .address(ram_addr), .data(ram_Data_In), .wren(ram_write_en), .q(ram_Data_out));
	
	//logic for choosing the ram_data_In and ram_addr    TODO    (for first part, initializer, no need 
	assign ram_addr = ram_Init_FSM_data_addr;
	assign ram_Data_In = ram_Init_FSM_data_addr;
	assign ram_write_en = 1;
	*/
	
	
	 
	 
	 
	 
	 
	// instantiating the 256 word 8bit RAM
	
	
endmodule



